-- Setting PSVITA at maximum speed
System.setCpuSpeed(444)
System.setBusSpeed(222)
System.setGpuSpeed(222)
System.setGpuXbarSpeed(166)
Sound.init()

-- Load sounds
local sndMusic = Sound.open("app0:/data/sounds/main.ogg")
local sndpistol = Sound.open("app0:/data/sounds/gun1.wav")
local sndauto = Sound.open("app0:/data/sounds/gun2.wav")
local sndshtgun = Sound.open("app0:/data/sounds/gun3.wav")
local sndpick = Sound.open("app0:/data/sounds/pick.wav")
local sndhammer = Sound.open("app0:/data/sounds/hammer.wav")

-- Load texures
local texGroundA = Graphics.loadImage("app0:/data/images/floor01.png")
local texCeilA = Graphics.loadImage("app0:/data/images/ceiling02.png")
local texSkybox = Graphics.loadImage("app0:/data/images/skybox.png")
local texWallA = Graphics.loadImage("app0:/data/images/wall01.png")
local texDoorA = Graphics.loadImage("app0:/data/images/door01.png")
local texDecals = Graphics.loadImage("app0:/data/images/detail.png")
local texDecalsB = Graphics.loadImage("app0:/data/images/detail2.png")
local texCouch = Graphics.loadImage("app0:/data/images/couch.png")
local texZombieA = Graphics.loadImage("app0:/data/images/zombie1.png")
local texZombieB = Graphics.loadImage("app0:/data/images/zombie2.png")
local texZombieC = Graphics.loadImage("app0:/data/images/zombie3.png")
local texShadow = Graphics.loadImage("app0:/data/images/shadow.png")

local texWood = Graphics.loadImage("app0:/data/images/wood.png")

local texWallguns = Graphics.loadImage("app0:/data/images/wallguns.png")

local texBed = Graphics.loadImage("app0:/data/images/bed.png")
local texKitchen = Graphics.loadImage("app0:/data/images/kitchen.png")
local texBlood = Graphics.loadImage("app0:/data/images/blood.png")

local gunA = Graphics.loadImage("app0:/data/images/gun01.png")
local gunB = Graphics.loadImage("app0:/data/images/gun02.png")
local gunC = Graphics.loadImage("app0:/data/images/gun03.png")

local fade = Graphics.loadImage("app0:/data/images/fade.png")
local flash = Graphics.loadImage("app0:/data/images/flash.png")

-- Load models
local modFloor = Render.loadObject("app0:/data/models/ground01.obj", texGroundA)
local modCeil = Render.loadObject("app0:/data/models/ground01.obj", texCeilA)
local modSky = Render.loadObject("app0:/data/models/skysphere.obj", texSkybox)
local modWall = Render.loadObject("app0:/data/models/wall1.obj", texWallA)

local modBullet = Render.loadObject("app0:/data/models/bull.obj", texCeilA)

local houseA1 = Render.loadObject("app0:/data/models/houseA1.obj", texWallA)
local houseA2 = Render.loadObject("app0:/data/models/houseA2.obj", texDoorA)
local houseA3 = Render.loadObject("app0:/data/models/houseA3.obj", texDecals)
local houseAB3 = Render.loadObject("app0:/data/models/houseA3.obj", texDecalsB)
local houseA4 = Render.loadObject("app0:/data/models/houseA4.obj", texKitchen)
local houseA5 = Render.loadObject("app0:/data/models/houseA5.obj", texBed)
local houseA6 = Render.loadObject("app0:/data/models/houseA6.obj", texCouch)
local houseA7 = Render.loadObject("app0:/data/models/houseGuns.obj", texWallguns)

local modWinA = Render.loadObject("app0:/data/models/win1.obj", texWood)
local modWinB = Render.loadObject("app0:/data/models/win2.obj", texWood)
local modWinC = Render.loadObject("app0:/data/models/win3.obj", texWood)
local modWinD = Render.loadObject("app0:/data/models/win4.obj", texWood)
local modWinE = Render.loadObject("app0:/data/models/win5.obj", texWood)

local modZmbA1 = Render.loadObject("app0:/data/models/zmba1.obj", texZombieA)
local modZmbA2 = Render.loadObject("app0:/data/models/zmba2.obj", texZombieA)
local modZmbA3 = Render.loadObject("app0:/data/models/zmba3.obj", texZombieA)
local modZmbA4 = Render.loadObject("app0:/data/models/zmba4.obj", texShadow)

local modZmbB1 = Render.loadObject("app0:/data/models/zmba1.obj", texZombieB)
local modZmbB2 = Render.loadObject("app0:/data/models/zmba2.obj", texZombieB)
local modZmbB3 = Render.loadObject("app0:/data/models/zmba3.obj", texZombieB)

local modZmbC1 = Render.loadObject("app0:/data/models/zmbb1.obj", texZombieC)
local modZmbC2 = Render.loadObject("app0:/data/models/zmbb2.obj", texZombieC)
local modZmbC3 = Render.loadObject("app0:/data/models/zmbb3.obj", texZombieC)

local modZmbD1 = Render.loadObject("app0:/data/models/zmbb1.obj", texZombieA)
local modZmbD2 = Render.loadObject("app0:/data/models/zmbb2.obj", texZombieA)
local modZmbD3 = Render.loadObject("app0:/data/models/zmbb3.obj", texZombieA)

local modPrtcl = Render.loadObject("app0:/data/models/prtcl.obj", texBlood)


-- Set texture filters
Graphics.setImageFilters(texGroundA, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texCeilA, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texWallA, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texSkybox, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texWood, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texDoorA, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texDecals, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texDecalsB, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texKitchen, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texBed, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texCouch, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texZombieA, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texZombieB, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texZombieC, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texShadow, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texBlood, FILTER_LINEAR, FILTER_LINEAR)
Graphics.setImageFilters(texWallguns, FILTER_LINEAR, FILTER_LINEAR)

Sound.play(sndMusic, LOOP)

local white = Color.new(250, 250, 250) 
local red = Color.new(220, 0, 0) 
local black = Color.new(0, 0, 0)

local oldpad = 0

local gameover = false
local totalenemies = 0

-- Set player angle, position and translation values
local playerz = -13.0
local playerx = 10.0
local playery = 5.2
local angleX = 0.0
local angleY = 3.1415 
local rotation = 0.0
local plrspeed = 0.02
local walkY = 0.0
local stepup = true
local shootDelay = 0.0
local plrot = 0.0
local plrotx = 0.0

local weapon = 0
--local gunAmmoA = 0
local gunAmmoB = 0
local gunAmmoC = 0

local gunclipA = 20
local gunclipB = 0
local gunclipC = 0

local score = 0
local recoil = 0

local hurtdelay = 0.0
local repairdelay = 9.0
local buytimer = 0.0
local gunprice = 0
local buygun = 0

local swaptimer = 0.0
local spawnTimer = 50.0
local enm1rot = 0.0

local winDmgA = 50.0
local winTimerA = 0.0
local winDmgB = 50.0
local winTimerB = 0.0
local winDmgC = 50.0
local winTimerC = 0.0
local winDmgD = 50.0
local winTimerD = 0.0
local winDmgE = 50.0
local winTimerE = 0.0

local wave = 1
local changewave = 20.0
local zombieskilled = 0
local zombiesneeded = 10

local paused = false

bulletSpeed = 0.6
local bullets = {}
local enemies = {}
local particle = {}
player = {x=0, y=0, z=0, width=1, height=1}

local mainfnt = Font.load("app0:/data/font.ttf")

local function move(speed)
	rotation = angleY--math.atan2(angleY, angleX)
	playerz = playerz - (speed * math.cos(rotation))
	playerx = playerx - (speed * math.sin(rotation))
	
	--Walking animation
	if walkY < 0 then
		stepup=true
	elseif walkY > 0.3 then
		stepup=false
	end
	
	if stepup == true then
		walkY = walkY + (plrspeed/8)
	else
		walkY = walkY - (plrspeed/8)
end

end
local function sidewalk(speed)
	rotation = angleY--math.atan2(angleY, angleX)
	playerx = playerx - (speed * math.cos(rotation))
	playerz = playerz + (speed * math.sin(rotation))
end

function shoot(x, y, z, angle, button)
	if button == 1 then
	--spawn bullet
		local startX = playerx
		local startZ = playerz
		table.insert(bullets, {x = startX, y = 4, z = startZ, dx = bulletDx, dz = bulletDy, angle = angle})
	end
end

function spawnEnemy(x, y, z, angle, button)
	if button == 1 then
	local zmbType = math.ceil(math.random(0, 4))
	--spawn enemy
		local enemyDx = 1 * math.cos(rotation)
		local enemyDy = 1 * math.sin(rotation)
		totalenemies = totalenemies + 1
		
		table.insert(enemies, {x = x, y = 0, z = z, vdx = enemyDx, vdz = enemyDy, angle = angleY, zleginv = false, zlegrot = 0.0, health = 80.0+ (wave*7), zmbType = zmbType})
	end
end

function spawnParticle(x, y, z, angle)
	--spawn blood particle
	table.insert(particle, {x = x, y = 0, z = z, angle = angleY})
end

function reload()
	if weapon==0 then
			gunclipA = 20
			swaptimer=200
			Sound.play(sndpick, NO_LOOP)
	elseif weapon==1 then
		if gunAmmoB>0 then
			if gunAmmoB>=60 then
			swaptimer=300
			tmpammo = 60 - gunclipB
			gunAmmoB = gunAmmoB - tmpammo
			gunclipB = 60
			Sound.play(sndpick, NO_LOOP)
			elseif gunAmmoB<60 then
			swaptimer=300
			gunclipB = gunAmmoB
			gunAmmoB = 0
			Sound.play(sndpick, NO_LOOP)
			end
		end					
	elseif weapon==2 then
		if gunAmmoC>0 then
			if gunAmmoC>=2 then
			swaptimer=400
			tmpammo = 2 - gunclipC
			gunAmmoC = gunAmmoC - tmpammo
			gunclipC = 2
			Sound.play(sndpick, NO_LOOP)
			elseif gunAmmoC<2 then
			swaptimer=400
			gunclipC = gunAmmoC
			gunAmmoC = 0
			Sound.play(sndpick, NO_LOOP)
			end
		end
	end
end

-- Main loop
while true do

	-- Controls checking
	pad = Controls.read()
	mx, my = Controls.readLeftAnalog()
	cx, cy = Controls.readRightAnalog()
	
	plrot = math.deg (angleY)
	plrotx = math.deg (angleX)-180
	
	if buytimer>0 then
		buytimer = buytimer - 0.1
	else
		buytimer=0
	end
		
	if swaptimer>0 then
		swaptimer = swaptimer - 1.5
	end
	
	--random spawn enemies
	if gameover == false then
		 
		if zombieskilled >= zombiesneeded then
			wave = wave + 1
			if wave<10 then
			spawnTimer=100 + math.ceil(math.random(0, 150))-(wave*10)
			else
			spawnTimer=100 + math.ceil(math.random(0, 150))-(100)
			end
			zombiesneeded = zombieskilled + (wave+10)
			changewave = 20
		end
	
		if spawnTimer>0 then
			if zombieskilled < zombiesneeded then
			spawnTimer = spawnTimer - 0.1
			end
		else
		if totalenemies < zombiesneeded-zombieskilled then
		local spawnPos = math.ceil(math.random(0, 4))
			if spawnPos==0 then
				spawnEnemy(-10, 0, 21, 0, 1)
			elseif spawnPos==1 then
				spawnEnemy(-25, 0, -4, 0, 1)
			elseif spawnPos==2 then
				spawnEnemy(25, 0, -4, 0, 1)
			elseif spawnPos==3 then
				spawnEnemy(10, 0, 21, 0, 1)
			end
		spawnTimer=50 + math.ceil(math.random(0, 180))
		end
		end
	else
		if playery>0.7 then
			playery = playery - 0.02
		end
	end
	
	if recoil>0 then
		recoil = recoil - 0.5
	end

	
	if shootDelay>0 then
	shootDelay = shootDelay - 0.1
	else
	shootDelay=0
	
	end
	
	--update bullet positions
	for i,v in ipairs(bullets) do

	local bulangle = v.angle
	v.x = v.x - (bulletSpeed * math.sin(bulangle))
	v.z = v.z - (bulletSpeed * math.cos(bulangle))

		
	-- bullet collisions
	if v.x < -5.7 and v.z < -9.8 then
		table.remove(bullets,i)
	end
	if v.x < -3 and v.x > -5 and v.z < -9 then
		table.remove(bullets,i)
	end
	
	if v.x < 7 and v.x > 4 and v.z > 0 then
		table.remove(bullets,i)
	end
	if v.x > 3 and v.x < 6 and v.z > 1 then
		table.remove(bullets,i)
	end
	
	if v.z < 1 and v.z > -1 and v.x > -9 and v.x < 4 then
		table.remove(bullets,i)
	end
	if v.z > -1 and v.z < 1 and v.x > -9 and v.x < 5 then
		table.remove(bullets,i)
	end
	
	
	if v.z < 1 and v.z > -1 and v.x < -11.5 then
		table.remove(bullets,i)
	end
	if v.z > -1 and v.z < 1 and v.x < -11.5 then
		table.remove(bullets,i)
	end

		--destroy bullet when out of house
		if v.x>33 or v.x<-33 or v.z>28 or v.z<-28 then
			table.remove(bullets,i)
		end
	end	

	
	-- Blend the model with info on screen
	Graphics.initBlend()
	Screen.clear()
	
	Render.drawModel(modSky, playerx, playery, playerz, 0, 0, 0)
	-- Map
	Render.drawModel(modFloor, 0, 0, 0, 0, 0, 0)
	Render.drawModel(modCeil, 0, 10, 0, 0, 0, 0)
	Render.drawModel(houseA1, 0, 0, 0, 0, 0, 0) 
	Render.drawModel(houseA2, 0, 0, 0, 0, 0, 0) 
	Render.drawModel(houseA3, 0, 0, 0, 0, 0, 0) 
	Render.drawModel(houseAB3, 0, 9.85, 0, 0, 0, 0) 
	Render.drawModel(houseA4, 0, 0, 0, 0, 0, 0) 
	Render.drawModel(houseA5, 0, 0, 0, 0, 0, 0) 
	Render.drawModel(houseA6, 0, 0, 0, 0, 0, 0) 
	Render.drawModel(houseA7, 0, 0, 0, 0, 0, 0) 
	
	if winDmgA>0 then
	Render.drawModel(modWinA, 10, 0, 19.4, 0, 0, 0)
	end
	if winDmgA>10 then
	Render.drawModel(modWinB, 10, 0, 19.4, 0, 0, 0) 
	end
	if winDmgA>20 then
	Render.drawModel(modWinC, 10, 0, 19.4, 0, 0, 0) 
	end
	if winDmgA>30 then
	Render.drawModel(modWinD, 10, 0, 19.4, 0, 0, 0) 
	end
	if winDmgA>40 then
	Render.drawModel(modWinE, 10, 0, 19.4, 0, 0, 0) 
	end
		
	if winDmgB>0 then
	Render.drawModel(modWinA, -10, 0, 19.4, 0, 0, 0)
	end
	if winDmgB>10 then
	Render.drawModel(modWinB, -10, 0, 19.4, 0, 0, 0) 
	end
	if winDmgB>20 then
	Render.drawModel(modWinC, -10, 0, 19.4, 0, 0, 0) 
	end
	if winDmgB>30 then
	Render.drawModel(modWinD, -10, 0, 19.4, 0, 0, 0) 
	end
	if winDmgB>40 then
	Render.drawModel(modWinE, -10, 0, 19.4, 0, 0, 0) 
	end
			
	if winDmgC>0 then
	Render.drawModel(modWinA, -24.5, 0, -5, 0, 270, 0)
	end
	if winDmgC>10 then
	Render.drawModel(modWinB, -24.5, 0, -5, 0, 270, 0) 
	end
	if winDmgC>20 then
	Render.drawModel(modWinC, -24.5, 0, -5, 0, 270, 0) 
	end
	if winDmgC>30 then
	Render.drawModel(modWinD, -24.5, 0, -5, 0, 270, 0) 
	end
	if winDmgC>40 then
	Render.drawModel(modWinE, -24.5, 0, -5, 0, 270, 0) 
	end
	
			
	if winDmgD>0 then
	Render.drawModel(modWinA, 24.5, 0, -5, 0, 90, 0)
	end
	if winDmgD>10 then
	Render.drawModel(modWinB, 24.5, 0, -5, 0, 90, 0) 
	end
	if winDmgD>20 then
	Render.drawModel(modWinC, 24.5, 0, -5, 0, 90, 0) 
	end
	if winDmgD>30 then
	Render.drawModel(modWinD, 24.5, 0, -5, 0, 90, 0) 
	end
	if winDmgD>40 then
	Render.drawModel(modWinE, 24.5, 0, -5, 0, 90, 0) 
	end
	
	--update enemy positions
	for i,env in ipairs(enemies) do
	if gameover == false and paused == false then
	-- animation
	if env.zleginv==true then 
		env.zlegrot = env.zlegrot + 0.05
		else
		env.zlegrot = env.zlegrot - 0.05
	end
	if env.zlegrot >4 then 
		env.zleginv=false
		elseif env.zlegrot <-4 then 
		env.zleginv=true
	end

	--look at player
	local enangle = math.atan2(env.z - playerz, env.x - playerx)
	enm1rot = math.deg (enangle)
	--move forward
	enmrotation = 90-enangle
		if env.zmbType == 3 or wave>4 then
			env.x = env.x - (0.012 * math.sin(enmrotation))
			env.z = env.z - (0.012 * math.cos(enmrotation))	
		else
			if env.zleginv==true then 
				env.x = env.x - (0.012 * math.sin(enmrotation))
				env.z = env.z - (0.012 * math.cos(enmrotation))	
			end
		end
	env.angle = enm1rot
	
	end
	
	if env.zmbType == 1 then
	Render.drawModel(modZmbA1, env.x, env.y+3.4, env.z, env.zlegrot, -90-env.angle, 0)
	Render.drawModel(modZmbA2, env.x, env.y+3.4, env.z, env.zlegrot, -90-env.angle, 0) 	
	Render.drawModel(modZmbA3, env.x, env.y+3.4, env.z, -env.zlegrot, -90-env.angle, 0) 
	elseif env.zmbType == 2 then
	Render.drawModel(modZmbB1, env.x, env.y+3.4, env.z, env.zlegrot, -90-env.angle, 0)
	Render.drawModel(modZmbB2, env.x, env.y+3.4, env.z, env.zlegrot, -90-env.angle, 0) 	
	Render.drawModel(modZmbB3, env.x, env.y+3.4, env.z, -env.zlegrot, -90-env.angle, 0)
	elseif env.zmbType == 3 then
	Render.drawModel(modZmbD1, env.x, env.y+3.4, env.z, env.zlegrot, -90-env.angle, 0)
	Render.drawModel(modZmbD2, env.x, env.y+3.4, env.z, env.zlegrot, -90-env.angle, 0) 	
	Render.drawModel(modZmbD3, env.x, env.y+3.4, env.z, -env.zlegrot, -90-env.angle, 0) 
	else 
	Render.drawModel(modZmbC1, env.x, env.y+3.4, env.z, env.zlegrot, -90-env.angle, 0)
	Render.drawModel(modZmbC2, env.x, env.y+3.4, env.z, env.zlegrot, -90-env.angle, 0) 	
	Render.drawModel(modZmbC3, env.x, env.y+3.4, env.z, -env.zlegrot, -90-env.angle, 0) 
	end
	
	Render.drawModel(modZmbA4, env.x, env.y+3.4, env.z, 0, -90-env.angle, 0) 		
	
	if env.x < playerx+1 and env.x > playerx-1 and env.z < playerz+1 and env.z > playerz-1 then
	  if gameover==false and env.health>0 then
		if hurtdelay<0.1 then
			hurtdelay = 40
		elseif hurtdelay<28 then
			--game over
			gameover = true
		end
	  end
	end
	
	-- Enemy collisions
	-- windows pos
	if paused == false then
	if env.x > 8 and env.x < 12 and env.z > 19 then
		if winDmgA>0 then
		winDmgA = winDmgA - 0.02
		env.z = 21
		env.x = 10
		end
	end
	
	if env.x > -11 and env.x < -9 and env.z > 19 then
		if winDmgB>0 then
		winDmgB = winDmgB - 0.02
		env.z = 21
		env.x = -10
		end
	end	
	
	if env.z > -5 and env.z < -3 and env.x < -22 then
		if winDmgC>0 then
		winDmgC = winDmgC - 0.02
		env.z = -4
		env.x = -26
		end
	end
	
	if env.z > -5 and env.z < -3 and env.x > 22 then
		if winDmgD>0 then
		winDmgD = winDmgD - 0.02
		env.z = -4
		env.x = 26
		end
	end
	end
	if env.x < -5.7 and env.z < -8.5 then
		env.z = -8.4
	end
	if env.x < -3 and env.x > -5 and env.z < -8.5 then
		env.x = -3
	end
	
	if env.x < 7 and env.x > 4 and env.z > 0 then
		env.x = 7
	end
	if env.x > 3 and env.x < 6 and env.z > 1 then
		env.x = 3
	end
	
	if env.z > -2 and env.z < 1 and env.x > -9.5 and env.x < 5 then
		env.z = -2
		if playerz>env.z then
		env.x = env.x + 0.04
		else
		env.x = env.x - 0.04
		end
	end
	if env.z < 1 and env.z > -1 and env.x > -9.5 and env.x < 5 then
		env.z = 1
		if playerz>env.z then
		env.x = env.x + 0.04
		else
		env.x = env.x - 0.04
		end
	end
	
	if env.z < 1 and env.z > -1 and env.x < -11 then
		env.z = 1
		env.x = env.x + 0.03
	end
	if env.z > -2 and env.z < 1 and env.x < -11 then
		env.z = -2
		env.x = env.x + 0.03
	end

	if env.z < 1.5 and env.z > -1.5 and env.x > -11.5 and env.x < -9 then
		env.x = -10
	end
	
	-- bed
	if env.z < 10 and env.z > 9 and env.x > -3 and env.x < 4 then
		env.z = 9
	end
	if env.z > 9 and env.x > -3 and env.x < 4 then
		env.x = -3
	end
	-- sofa
	if env.z < -7 and env.z > -8 and env.x > 19 then
		env.z = -7
	end
	if env.z < -7 and env.x > 19 then
		env.x = 19
	end
	-- kitchen
	if env.z < 5 and env.z > 4 and env.x > 21 then
		env.z = 4
	end
	if env.z > 4 and env.x > 21 then
		env.x = 21
	end
	if env.z < 16 and env.z > 15 and env.x > 15 then
		env.z = 15
	end
	if env.z > 15 and env.x > 15 then
		env.x = 15
	end
	
	-- table
	if env.z < 3 and env.z > 2 and env.x > 6 and env.x < 9 then
		env.z = 2
		env.x = env.x + 0.02
	end
	if env.z < 12 and env.z > 11 and env.x > 6 and env.x < 9 then
		env.z = 12
		env.x = env.x + 0.02
	end
	if env.z > 2 and env.z < 12 and env.x < 10 and env.x > 6 then
		env.x = 10
	end

	
	for i,v in ipairs(bullets) do
		--bullet hit enemy
		if v.x>env.x-1 and v.x<env.x+1 and v.z>env.z-1 and v.z<env.z+1 then
			if plrotx<-170 then
			table.remove(bullets,i)
			spawnParticle(env.x, env.y, env.z, env.angle)
			if weapon == 2 then
			env.health = env.health - 60.0
			else
			env.health = env.health - 30.0
			end
			env.zlegrot = 8
			score = score + 10
			--table.remove(enemies,i)
			end
		end
	end	
	
	if env.health<=0 then
	if env.y>-6 then
		 env.zlegrot = env.zlegrot - 0.8
		env.y = env.y - 0.04
	else
		table.remove(enemies,i)
		totalenemies = totalenemies - 1
		zombieskilled = zombieskilled + 1
		score = score + 100
	end
	
	end
	
	end
	
	
	for i,prt in ipairs(particle) do
	local prtrot = angleY
	prt.z = prt.z + (0.05 * math.cos(prtrot))
	prt.x = prt.x + (0.05 * math.sin(prtrot))
	
		Render.drawModel(modPrtcl, prt.x, prt.y+4, prt.z, 0, -90-prt.angle, 0) 

		prt.y = prt.y - 0.02
		
		if prt.y< -2 then
			table.remove(particle,i)
		end
		
	end
	
	Render.setCamera(playerx, playery+walkY, playerz, angleX, angleY, 0.0)

	if hurtdelay>0 then
		hurtdelay = hurtdelay -0.02
		Graphics.fillRect(0, 1280, 0, 720, Color.new(240, 0, 0, hurtdelay*3))
	else
		hurtdelay=0
	end
	
	Graphics.drawImage(0, 0, fade)
	
  if gameover==false then
	-- Draw Weapons
	if weapon==0 then
		if shootDelay>16 then
			Graphics.drawImage(530+ (cx/4), 260+ (walkY*100) + (angleX*70) + swaptimer + recoil, flash)
		end
		Graphics.drawImage(640 + (cx/4), 390 + (walkY*100) + (angleX*70) + swaptimer + recoil, gunA)
	end
	if weapon==1 then
		if shootDelay>5 then
			Graphics.drawImage(530+ (cx/4), 260+ (walkY*100) + (angleX*70) + swaptimer + recoil, flash)
		end
		Graphics.drawImage(500 + (cx/4), 370 + (walkY*100) + (angleX*70) + swaptimer + recoil, gunB)
	end
	if weapon==2 then
		if shootDelay>20 then
			Graphics.drawImage(500+ (cx/4), 260+ (walkY*100) + (angleX*70) + swaptimer + recoil, flash)
		end
		Graphics.drawImage(530 + (cx/4), 380 + (walkY*100) + (angleX*70) + swaptimer + recoil, gunC)
	end
	
  end
  
	-- Player collisions
	if  paused == false then
	if buytimer==0 then
		if playerx < -1 and playerx > -4 and playerz > -15 and playerz < -9 then
			gunprice = 800
			buygun=1
		elseif playerx < 1.5 and playerx > -2 and playerz > 2 and playerz < 3.5 then
			gunprice = 1200
			buygun=2
		else
			gunprice = 0
			buygun=0
		end
	end
	
	if repairdelay>10 then
		repairdelay = 0
		Sound.play(sndhammer, NO_LOOP)
		score = score + 10
	end
	-- windows
	if playerx > 7 and playerx < 13 and playerz > 16 then
		if winDmgA<50 then
			Font.setPixelSizes(mainfnt, 24)
			Font.print(mainfnt, 340, 320, "Hold O to Rebuild Barrier", white)
			if Controls.check(pad, SCE_CTRL_CIRCLE) then
				winDmgA = winDmgA + 0.03
				repairdelay = repairdelay +0.03
			end
		end
	end
	if playerx > -12 and playerx < -8 and playerz > 16 then
		if winDmgB<50 then
			Font.setPixelSizes(mainfnt, 24)
			Font.print(mainfnt, 340, 320, "Hold O to Rebuild Barrier", white)
			if Controls.check(pad, SCE_CTRL_CIRCLE) then
				winDmgB = winDmgB + 0.03
				repairdelay = repairdelay +0.03
			end
		end
	end
	
	
	if playerz > -6 and playerz < -2 and playerx < -21 then
		if winDmgC<50 then
			Font.setPixelSizes(mainfnt, 24)
			Font.print(mainfnt, 340, 320, "Hold O to Rebuild Barrier", white)
			if Controls.check(pad, SCE_CTRL_CIRCLE) then
				winDmgC = winDmgC + 0.03
				repairdelay = repairdelay +0.03
			end
		end
	end
	
	if playerz > -6 and playerz < -2 and playerx > 21 then
		if winDmgD<50 then
			Font.setPixelSizes(mainfnt, 24)
			Font.print(mainfnt, 340, 320, "Hold O to Rebuild Barrier", white)
			if Controls.check(pad, SCE_CTRL_CIRCLE) then
				winDmgD = winDmgD + 0.03
				repairdelay = repairdelay +0.03
			end
		end
	end
	
	end
	
	if playerx < -23 then
		playerx = -23
	end
	if playerx > 23 then
		playerx = 23
	end
	if playerz > 18 then
		playerz = 18
	end
	if playerz < -18 then
		playerz = -18
	end
	if playerx < -4 and playerz < -9 then
		playerz = -9
	end
	
	if playerx > -5.2 and playerx < -4 and playerz < -9.8 then
		playerx = -5.2
	end
	
	if playerx < -3 and playerx > -5 and playerz < -9 then
		playerx = -3
	end
	
	if playerx < 7 and playerx > 4 and playerz > 0 then
		playerx = 7
	end
	if playerx > 3 and playerx < 6 and playerz > 1 then
		playerx = 3
	end
	
	if playerz < 2.5 and playerz > -1 and playerx > -9 and playerx < 4 then
		playerz = 2.5
	end
	if playerz > -2 and playerz < 1 and playerx > -9 and playerx < 5 then
		playerz = -2
	end
	
	if playerz < 2.5 and playerz > -1 and playerx < -11.5 then
		playerz = 2.5
	end
	if playerz > -2 and playerz < 1 and playerx < -11.5 then
		playerz = -2
	end
	if playerz > -2 and playerz < 2 and playerx < -11 then
		playerx = -11
	end
	if playerz > -2 and playerz < 2 and playerx > -9.5 and playerx < -8 then
		playerx = -9.5
	end
	
	-- bed
	if playerz < 10 and playerz > 9 and playerx > -3 and playerx < 4 then
		playerz = 9
	end
	if playerz > 9 and playerx > -3 and playerx < 4 then
		playerx = -3
	end
	-- sofa
	if playerz < -7 and playerz > -8 and playerx > 19 then
		playerz = -7
	end
	if playerz < -7 and playerx > 19 then
		playerx = 19
	end
	-- kitchen
	if playerz < 5 and playerz > 4 and playerx > 21 then
		playerz = 4
	end
	if playerz > 4 and playerx > 21 then
		playerx = 21
	end
	if playerz < 16 and playerz > 15 and playerx > 15 then
		playerz = 15
	end
	if playerz > 15 and playerx > 15 then
		playerx = 15
	end
	
	-- table
	if playerz < 3 and playerz > 2 and playerx > 6 and playerx < 10 then
		playerz = 2
	end
	if playerz < 12 and playerz > 11 and playerx > 6 and playerx < 10 then
		playerz = 12
	end
	if playerz > 2 and playerz < 12 and playerx < 10 and playerx > 6 then
		playerx = 10
	end
	
	
	
	
  if gameover==false and paused == false then
	--Move with Left Analog
	if my < 64 then
		move(plrspeed)
	elseif my > 180 then
		move(-plrspeed)
	end
	
	--Strafe with Left Analog
	if mx < 64 then
		sidewalk(plrspeed) 
	elseif mx > 180 then
		sidewalk(-plrspeed) 
	end
	
	--Rotate with Right Analog
	if cx < 64 then
		angleY = angleY + 0.008*((64-cx)/64)
		if angleY>=6.2831853072 then
			angleY=0
		end
	elseif cx > 180 then
		angleY = angleY - 0.008*(-(180-cx)/64)
		if angleY<=0 then
			angleY=6.283185
		end
	end
	
	--Rotate up/down with Right Analog
	if cy < 64 then 
		if angleX < 0.8 then
			angleX = angleX + 0.004
		end
	elseif cy > 180 then 
		if angleX > -0.8 then
			angleX = angleX - 0.004
		end
	end
  end
  
	
	if Controls.check(pad, SCE_CTRL_RTRIGGER) then
	--Fire
		if shootDelay==0 and swaptimer<1 and gameover==false and paused == false then
			if weapon==0 then
				if gunclipA>0 then
					gunclipA = gunclipA - 1
					shootDelay=18
					Sound.play(sndpistol, NO_LOOP)
					shoot(playerx, playery, playerz, angleY, 1)
					recoil = 14
					else
					gunclipA = 20
					swaptimer=200
					Sound.play(sndpick, NO_LOOP)
				end
			elseif weapon==1 then
				if gunAmmoB>0 or gunclipB>0 then
					if gunclipB>0 then
					gunclipB = gunclipB -1
					shootDelay=6
					Sound.play(sndauto, NO_LOOP)
					shoot(playerx, playery, playerz, angleY, 1)
					recoil = 20
					else
						if gunAmmoB>=60 then
							swaptimer=300
							gunclipB = 60
							gunAmmoB = gunAmmoB - 60
							Sound.play(sndpick, NO_LOOP)
						elseif gunAmmoB>0 then
							swaptimer=300
							gunclipB = gunAmmoB
							gunAmmoB = 0
							Sound.play(sndpick, NO_LOOP)
						else
							swaptimer=200
							weapon=0
						end
					end					
				else
					weapon=0
				end
			elseif weapon==2 then
				if gunAmmoC>0 or gunclipC>0 then
					if gunclipC>0 then
					gunclipC = gunclipC -1
					shootDelay=25
					Sound.play(sndshtgun, NO_LOOP)
					shoot(playerx, playery, playerz, angleY, 1)
					recoil = 35
					else
						if gunAmmoC>=2 then
							swaptimer=400
							gunclipC = 2
							gunAmmoC = gunAmmoC - 2
							Sound.play(sndpick, NO_LOOP)
						elseif gunAmmoC>0 then
							swaptimer=400
							gunclipC = gunAmmoC
							gunAmmoC = 0
							Sound.play(sndpick, NO_LOOP)
						else
							swaptimer=200
							weapon=0
						end
					end					
				else
					weapon=0
				end
			end
		end
	end
	

	if Controls.check(pad, SCE_CTRL_CROSS) then
	plrspeed = 0.05
	else
	plrspeed = 0.03
	end

	if Controls.check(pad, SCE_CTRL_SQUARE) then
		if gameover == false and paused == false and swaptimer<1 then
			reload()
		end
	end
	if Controls.check(pad, SCE_CTRL_CIRCLE) and paused==true then
		paused=false
	end
	
if gunprice>0 and swaptimer<1 and paused == false then
	Font.setPixelSizes(mainfnt, 24)
	Font.print(mainfnt, 280, 300, "Press O to buy this weapon [Cost: " .. gunprice .. "]", white)
	if score < gunprice then
		Font.print(mainfnt, 360, 350, "Not enough credits", red)
	end
	
	if Controls.check(pad, SCE_CTRL_CIRCLE) and buytimer==0 then
		if score >= gunprice then
			buytimer = 40
			Sound.play(sndpick, NO_LOOP)
			weapon = buygun
			if buygun == 1 then
				gunAmmoB = gunAmmoB + 240
				gunclipB = 60
				gunclipC = 0
				gunAmmoC=0
			elseif buygun == 2 then
				gunAmmoC = gunAmmoC + 60
				gunclipB = 0
				gunclipC = 2
				gunAmmoB=0
			end
			swaptimer=200
			score = score - gunprice
		else
			buytimer = 30
		end
	end
end

Font.setPixelSizes(mainfnt, 28)
Font.print(mainfnt, 20, 450, "" .. score, white)--Draw Score

Font.setPixelSizes(mainfnt, 36)
Font.print(mainfnt, 20, 480, "WAVE " .. wave, red)

-- Draw Ammo
if weapon==0 then
	Font.print(mainfnt, 860, 480, gunclipA .. "/-", white)--Draw Score ∞
elseif weapon==1 then
	Font.print(mainfnt, 860, 480, gunclipB .. "/" .. gunAmmoB, white)
elseif weapon==2 then
	Font.print(mainfnt, 860, 480, gunclipC .. "/" .. gunAmmoC, white)
end


Graphics.debugPrint(476,268,"+",white)

if  paused == true then
	Font.setPixelSizes(mainfnt, 64)
	Font.print(mainfnt, 380, 180, "PAUSED", white)
	Font.setPixelSizes(mainfnt, 32)
	Font.print(mainfnt, 384, 294, "CIRCLE: Resume\nTRIANGLE: Quit", white)

end


if gameover == true then
	Font.setPixelSizes(mainfnt, 80)
	Font.print(mainfnt, 360, 180, "GAME OVER", red)
	
	Font.setPixelSizes(mainfnt, 32)
	Font.print(mainfnt, 384, 294, "Kills: " .. zombieskilled .. "\nScore: " .. score, black)
	Font.print(mainfnt, 380, 290, "Kills: " .. zombieskilled .. "\nScore: " .. score, white)
	Font.print(mainfnt, 400, 440, "Press O to Exit", white)
	if Controls.check(pad, SCE_CTRL_CIRCLE) and hurtdelay<5 then
		Sound.close(sndMusic)
		Sound.close(sndpistol)
		Sound.close(sndauto)
		Sound.close(sndshtgun)
		Sound.close(sndpick)
		Font.unload(mainfnt)
		--break
		dofile("app0:/index.lua")
	end
	
else
	if changewave>0 then
	changewave = changewave - 0.02
	Font.setPixelSizes(mainfnt, 80)
	Font.print(mainfnt, 380, 180, "WAVE " .. wave, red)
	end
end

	-- Change Weapon
	if Controls.check(Controls.read(), SCE_CTRL_TRIANGLE) then
	if paused == true then
		Sound.close(sndMusic)
		Sound.close(sndpistol)
		Sound.close(sndauto)
		Sound.close(sndshtgun)
		Sound.close(sndpick)
		Font.unload(mainfnt)
		--break
		dofile("app0:/index.lua")
	end
	
	if swaptimer<1 and paused == false then
	
		if weapon==0 then
			if gunAmmoB>0 or gunclipB>0 then
				weapon=1
				swaptimer=170
			elseif gunAmmoC>0 or gunclipC>0 then
				weapon=2
				swaptimer=170
			else
				weapon=0
			end
		else
			swaptimer=170
			weapon=0
		end
	end

	end
   		
	-- Exit game
	if Controls.check(Controls.read(), SCE_CTRL_START) then
		if gameover == false and paused == false then
			paused = true
		end
	end
	
	Graphics.termBlend()
	Screen.flip()


end
