-- Loading resources
Sound.init()
local sndMusic = Sound.open("app0:/data/sounds/theme.ogg")
local sndpick = Sound.open("app0:/data/sounds/reload.wav")
local logo = Graphics.loadImage("app0:/logo.png")
local bg = Graphics.loadImage("app0:/data/images/back.png")
local controls = Graphics.loadImage("app0:/data/images/ctrls.png")
local black_transparent = Color.new(0, 0, 0, 100)

local fnt = Font.load("app0:/data/main.ttf")

-- Initializing oldpad variable
oldpad = SCE_CTRL_CROSS

-- Used colors
local white = Color.new(255, 255, 255)
local grey = Color.new(190, 190, 190)
local black = Color.new(0, 0, 0)
local red = Color.new(220, 0, 0)
local fadered = Color.new(220, 0, 0, 70)

imgalpha = 255
startdelay = 50.0

showcredits = false
showscores = false
showscontrols = false
local hiscore = 0

menu = {"Survival", "Controls", "Credits", "Quit"}
local master_index = 0
local p = 1

Sound.play(sndMusic, LOOP)

-- Main loop
while true do
	if startdelay>0 then
		startdelay = startdelay - 0.1
	else
		startdelay=0
		if imgalpha>0 then
			imgalpha = imgalpha - 1
		end
	end
	
	-- Starting drawing phase
	Graphics.initBlend()
	Screen.clear()

	-- Drawing background
	Graphics.drawImage(0,0, bg)
	Graphics.debugPrint(20, 522, "© 2017  VitaHEX Games | www.patreon.com/vitahex", white)
	
	-- Drawing Filebrowser
		base_y = 285
		for l, file in pairs(menu) do
			if (base_y > 960) then
				break
			end
			if (l >= master_index) then
				Graphics.fillRect(0, 180, base_y, base_y+22, fadered) 
				if (l==p) then
				color = grey
					if (base_y) == 0 then
						base_y = 50
				end
					Graphics.fillRect(0, 180, base_y, base_y+22, red) 
					Graphics.debugPrint(58+1, base_y+1, "" .. menu[p], black)

					color = white
					if (base_y) == 2 then
						base_y = 50
					end

				end
				--CropPrint(54, base_y,file.name,color, file.icon)
				--Graphics.debugPrint(58, base_y, "" .. menu.name, white)
				Graphics.debugPrint(58, base_y, "" .. menu[l], white)
				base_y = base_y + 26
			end
		end
	
	
	if showscontrols == true then
		-- CONTROLS
		Graphics.fillRect(0, 960, 0, 544, black)
		Font.setPixelSizes(fnt, 36)
		Font.print(fnt, 35, 60, "CONTROLS", grey)
		Graphics.drawImage(70,140, controls)
		
		Graphics.fillRect(0, 180, 480, 502, red) 
		Graphics.debugPrint(58, 480, "O  Back", white)
		
	end
	if showcredits == true then
		-- CREDITS
		Graphics.fillRect(0, 960, 0, 544, black)
		Font.setPixelSizes(fnt, 36)
		Font.print(fnt, 35, 60, "CREDITS", grey)
		Graphics.debugPrint(240, 120, "CREDITS\n\nDeveloped by\nVitaHEX Games\n\nPROGRAMMING, ART\nSakis Rg\n\nMUSIC\nwww.bensound.com\n\nEngine used\nLua Player Plus by\nRinnegatamante", white)
		
		Graphics.fillRect(0, 180, 480, 502, red) 
		Graphics.debugPrint(58, 480, "O  Back", white)
	end
	
	
	Graphics.drawLine(30, 930, 54, 54, white)
		
	Font.setPixelSizes(fnt, 36)
	Font.print(fnt, 35, 12, "ZOMBIEBOUND", white)
	Font.setPixelSizes(fnt, 18)
	Font.print(fnt, 857, 28, "ver. 0.1.0", grey)

		
	

	
	

	if showscores == true then
		-- CREDITS
		Graphics.fillRect(960, 700, 0, 518, black_transparent)
		Graphics.debugPrint(720, 50, "HI-SCORES\n\nBest: " .. hiscore, white)
	end
	
	-- Drawing description
	
	-- Drawing top right corner
	--Graphics.debugPrint(700, 5, "Press START to exit.", white)
		

	if imgalpha>0 then
	Graphics.drawImage(0,0, logo, Color.new(255, 255, 255, imgalpha))
	end
	
	-- Terminating drawing phase
	Graphics.termBlend()
	Screen.flip()
	
	-- Controls checking
	pad = Controls.read()
	if imgalpha<1 then
		if Controls.check(pad, SCE_CTRL_CROSS) and not Controls.check(oldpad, SCE_CTRL_CROSS) then
			if p == 1 then
				Sound.close(sndMusic)
				Sound.play(sndpick, NO_LOOP)
				dofile("app0:/gameplay.lua")
			elseif p == 2 then
				if showscontrols == false then
					showscontrols = true
					Sound.play(sndpick, NO_LOOP)
				end
			elseif p == 3 then
				if showscontrols == false then
					showcredits = true
					Sound.play(sndpick, NO_LOOP)
				end
			elseif p == 4 then
				--quit
				Sound.close(sndpick)
				Sound.close(sndMusic)
				Graphics.freeImage(logo)
				Graphics.freeImage(bg)
				Graphics.freeImage(controls)
				System.exit()
			end
		end

		if Controls.check(pad, SCE_CTRL_CIRCLE) then
		showscontrols = false
		showcredits = false
			if System.doesFileExist("ux0:/data/CTJ3Dsave.txt") then
			handle = System.openFile("ux0:/data/CTJ3Dsave.txt", FREAD)
			hiscore = System.readFile(handle, 10) 
			System.closeFile(handle)
			end

		end
		
	if showscontrols == false and showcredits == false then
		if (Controls.check(pad,SCE_CTRL_UP)) and not (Controls.check(oldpad,SCE_CTRL_UP)) then
			p = p - 1
			Sound.play(sndpick, NO_LOOP)
			if (p >= 1) then 
				master_index = p - 3
			end
		elseif (Controls.check(pad,SCE_CTRL_DOWN)) and not (Controls.check(oldpad,SCE_CTRL_DOWN)) then
			p = p + 1
			Sound.play(sndpick, NO_LOOP)
			if (p >= 3) then 
				master_index = p - 3
			end
		end
	end
		if p < 1 then
			p = #menu
			if p >= 4 then 
				master_index = p - 3
			end
		elseif p > #menu then
			master_index = 0
			p = 1
		end
		
	end
	
	-- Saving old controls scheme
	oldpad = pad
	
end